# SPDX-License-Identifier: AGPL-3.0-or-later
# Copyright 2024-2025 Max-Planck-Institut für Nachhaltige Materialien GmbH
# Copyright 2011-2024 Max-Planck-Institut für Eisenforschung GmbH
#
# DAMASK is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
import pytest
import numpy as np

import damask

@pytest.fixture
def res_path(res_path_base):
    """Directory containing testing resources."""
    return res_path_base/'thermal_isotropic'


def test_thermal_isotropic(res_path,tmp_path,copy_files,np_rng):
    grid = 'inclusion'
    load = 'no_deformation'
    material = 'material'
    copy_files(res_path,tmp_path)

    g = damask.GeomGrid.load(tmp_path/f'{grid}.vti')
    g.initial_conditions['T']=np.where(g.material==0,np_rng.random()*400,np_rng.random()*400)+200.
    g.save(tmp_path/f'{grid}.vti')

    damask.util.run(f'damask_grid -l {load}.yaml -g {grid}.vti -m {material}.yaml -j {grid}_{load} -n numerics.yaml',
                    wd=tmp_path)
    r_cube = damask.Result(tmp_path/f'{grid}_{load}.hdf5').place(['T','O']).values()

    m = damask.ConfigMaterial.load(tmp_path/f'{material}.yaml')
    m['material'][0]['constituents'][0]['O'] = damask.Rotation.from_random(rng_seed=np_rng)
    m['material'][1]['constituents'][0]['O'] = damask.Rotation.from_random(rng_seed=np_rng)
    m.save(tmp_path/f'{material}.yaml')

    damask.util.run(f'damask_grid -l {load}.yaml -g {grid}.vti -m {material}.yaml -j {grid}_{load} -n numerics.yaml',
                    wd=tmp_path)
    r_random = damask.Result(tmp_path/f'{grid}_{load}.hdf5').place(['T','O']).values()

    for cube,random in zip(r_cube,r_random):
        assert (        np.allclose(cube['thermal'],random['thermal'])
                and not np.allclose(cube['mechanical'],random['mechanical']))
